Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.distribution
Class ExponentialDistribution

    java.lang.Object
      org.apache.commons.math3.distribution.AbstractRealDistribution
          org.apache.commons.math3.distribution.ExponentialDistribution

All Implemented Interfaces:
  Serializable, RealDistribution

    public class ExponentialDistribution

extends AbstractRealDistribution

Implementation of the exponential distribution.

Version:
  $Id: ExponentialDistribution.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Exponential distribution (Wikipedia), Exponential distribution (MathWorld), Serialized Form

Field Summary
`static double` | `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy.

Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution
`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

Constructor Summary
`ExponentialDistribution(double mean)` Create an exponential distribution with the given mean.
`ExponentialDistribution(double mean, double inverseCumAccuracy)` Create an exponential distribution with the given mean.
`ExponentialDistribution(RandomGenerator rng, double mean, double inverseCumAccuracy)` Creates an exponential distribution.

Method Summary
`double` | `cumulativeProbability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double` | `density(double x)` Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double` | `getMean()` Access the mean.
`double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
`double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
`protected double` | `getSolverAbsoluteAccuracy()` Returns the solver absolute accuracy for inverse cumulative computation.
`double` | `getSupportLowerBound()` Access the lower bound of the support.
`double` | `getSupportUpperBound()` Access the upper bound of the support.
`double` | `inverseCumulativeProbability(double p)` Computes the quantile function of this distribution.
`boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
`boolean` | `isSupportLowerBoundInclusive()` Whether or not the lower bound of support is in the domain of the density function.
`boolean` | `isSupportUpperBoundInclusive()` Whether or not the upper bound of support is in the domain of the density function.
`double` | `sample()` Generate a random value sampled from this distribution.

Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution
`cumulativeProbability, probability, probability, reseedRandomGenerator, sample`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

    public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

  Default inverse cumulative probability accuracy.

  Since:
    2.1
  See Also:
    Constant Field Values

Constructor Detail

### ExponentialDistribution

    public ExponentialDistribution(double mean)

  Create an exponential distribution with the given mean.

  Parameters:
    `mean` - mean of this distribution.

### ExponentialDistribution

    public ExponentialDistribution(double mean,
                                   double inverseCumAccuracy)

  Create an exponential distribution with the given mean.

  Parameters:
    `mean` - Mean of this distribution.
    `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
  Throws:
    `NotStrictlyPositiveException` - if `mean <= 0`.
  Since:
    2.1

### ExponentialDistribution

    public ExponentialDistribution(RandomGenerator rng,
                                   double mean,
                                   double inverseCumAccuracy)
                            throws NotStrictlyPositiveException

  Creates an exponential distribution.

  Parameters:
    `rng` - Random number generator.
    `mean` - Mean of this distribution.
    `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
  Throws:
    `NotStrictlyPositiveException` - if `mean <= 0`.
  Since:
    3.1

Method Detail

### getMean

    public double getMean()

  Access the mean.

  Returns:
    the mean.

### density

    public double density(double x)

  Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

  Parameters:
    `x` - the point at which the PDF is evaluated
  Returns:
    the value of the probability density function at point `x`

### cumulativeProbability

    public double cumulativeProbability(double x)

  For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution. The implementation of this method is based on:
  - Exponential Distribution, equation (1).

  Parameters:
    `x` - the point at which the CDF is evaluated
  Returns:
    the probability that a random variable with this distribution takes a value less than or equal to `x`

### inverseCumulativeProbability

    public double inverseCumulativeProbability(double p)
                                        throws OutOfRangeException

  Computes the quantile function of this distribution. For a random variable `X` distributed according to this distribution, the returned value is
  - `inf{x in R | P(X<=x) >= p}` for `0 < p <= 1`,
  - `inf{x in R | P(X<=x) > 0}` for `p = 0`.
  The default implementation returns
  - `RealDistribution.getSupportLowerBound()` for `p = 0`,
  - `RealDistribution.getSupportUpperBound()` for `p = 1`.
  Returns `0` when `p= = 0` and `Double.POSITIVE_INFINITY` when `p == 1`.

  Specified by:
    `inverseCumulativeProbability` in interface `RealDistribution`
  Overrides:
    `inverseCumulativeProbability` in class `AbstractRealDistribution`
  Parameters:
    `p` - the cumulative probability
  Returns:
    the smallest `p`-quantile of this distribution (largest 0-quantile for `p = 0`)
  Throws:
    `OutOfRangeException` - if `p < 0` or `p > 1`

### sample

    public double sample()

  Generate a random value sampled from this distribution. The default implementation uses the inversion method.

  Algorithm Description: this implementation uses the Inversion Method to generate exponentially distributed random values from uniform deviates.

  Specified by:
    `sample` in interface `RealDistribution`
  Overrides:
    `sample` in class `AbstractRealDistribution`
  Returns:
    a random value.
  Since:
    2.2

### getSolverAbsoluteAccuracy

    protected double getSolverAbsoluteAccuracy()

  Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.

  Overrides:
    `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
  Returns:
    the maximum absolute error in inverse cumulative probability estimates

### getNumericalMean

    public double getNumericalMean()

  Use this method to get the numerical value of the mean of this distribution. For mean parameter `k`, the mean is `k`.

  Returns:
    the mean or `Double.NaN` if it is not defined

### getNumericalVariance

    public double getNumericalVariance()

  Use this method to get the numerical value of the variance of this distribution. For mean parameter `k`, the variance is `k^2`.

  Returns:
    the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

### getSupportLowerBound

    public double getSupportLowerBound()

  Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

  `inf {x in R | P(X <= x) > 0}`.

  The lower bound of the support is always 0 no matter the mean parameter.

  Returns:
    lower bound of the support (always 0)

### getSupportUpperBound

    public double getSupportUpperBound()

  Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

  `inf {x in R | P(X <= x) = 1}`.

  The upper bound of the support is always positive infinity no matter the mean parameter.

  Returns:
    upper bound of the support (always Double.POSITIVE_INFINITY)

### isSupportLowerBoundInclusive

    public boolean isSupportLowerBoundInclusive()

  Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

  Returns:
    true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportUpperBoundInclusive

    public boolean isSupportUpperBoundInclusive()

  Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

  Returns:
    true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportConnected

    public boolean isSupportConnected()

  Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

  Returns:
    `true`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.